routes/web.php
<?php

use App\Http\Controllers\GroupController;
use App\Http\Controllers\PermissionController;
use App\Http\Controllers\RoleController;
use App\Http\Controllers\SessionController;
use App\Http\Controllers\UserController;
use Illuminate\Support\Facades\App;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::group(['middleware' => 'auth'], function () {
    Route::get('/dashboard', function () {
        return view('dashboard');
    })->name('dashboard');

    Route::resource('users', UserController::class);

    Route::resource('roles', RoleController::class);

    Route::resource('groups', GroupController::class);

    Route::resource('sessions', SessionController::class);
});

Route::get('/', function () {
    return view('welcome');
});

require __DIR__.'/auth.php';

app/Models/User.php
<?php

namespace App\Models;

// use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'last_name',
        'first_name',
        'email',
        'password',
        'avatar',
        'title_id',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];

    public function scopeGetUsers()
    {
        return User::all();
    }

    public function groups()
    {
        return $this->belongsToMany(Group::class);
    }

    public function roles()
    {
        return $this->belongsToMany(Role::class);
    }

    public function sessions()
    {
        return $this->belongsToMany(Session::class);
    }

    public function title()
    {
        return $this->belongsTo(Title::class);
    }
}

app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\StoreUserRequest;
use App\Http\Requests\UpdateUserRequest;
use App\Models\Group;
use App\Models\Role;
use App\Models\Title;
use App\Models\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;

class UserController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $this->authorize('viewAny', User::class);

        $users = User::getUsers();

        return view('users.index', compact('users'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $this->authorize('create', User::class);

        $groups = Group::getGroups();
        $roles = Role::getRoles();
        $titles = Title::getTitles();

        return view('users.create', compact('groups', 'roles', 'titles'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(StoreUserRequest $request)
    {
        $this->authorize('create', User::class);

        $mailAlreadyUsed = User::where('email', $request->email)->first();
            
        if ($mailAlreadyUsed) return back()->with('userCreateFailure', 'Cette adresse mail est déjà utilisée');

        $user = User::create([
            'last_name' => $request->last_name,
            'first_name' => $request->first_name,
            'email' => $request->email,
            'password' => Hash::make($request->password),
            'avatar' => null,
            'title_id' => intval($request->title_id),
        ]);

        if ($request->group_id) $user->groups()->attach(array_map('intval', $request->group_id));
        else $user->groups()->attach([]);

        $user->roles()->attach(array_map('intval', $request->role_id));

        return back()->with('userCreateSuccess', "L'utilisateur a été créé avec succès");
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\User  $user
     * @return \Illuminate\Http\Response
     */
    public function show(User $user)
    {
        if (!$user) return back()->with('userViewFailure', "Cet utilisateur n'existe pas");

        $this->authorize('view', $user);

        $groups = Group::getGroups();
        $roles = Role::getRoles();
        $titles = Title::getTitles();

        return view('users.show', compact('user', 'groups', 'roles', 'titles'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\User  $user
     * @return \Illuminate\Http\Response
     */
    public function edit(User $user)
    {
        if (!$user) return back()->with('userUpdateFailure', "Cet utilisateur n'existe pas");

        $this->authorize('update', $user);

        $groups = Group::getGroups();
        $roles = Role::getRoles();
        $titles = Title::getTitles();

        return view('users.edit', compact('user', 'groups', 'roles', 'titles'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\User  $user
     * @return \Illuminate\Http\Response
     */
    public function update(UpdateUserRequest $request, User $user)
    {
        if (!$user) return back()->with('userUpdateFailure', "Cet utilisateur n'existe pas");

        $this->authorize('update', $user);

        if ($request->email !== $user->email) {
            $mailAlreadyUsed = User::where('email', $request->email)->first();
            
            if ($mailAlreadyUsed) return back()->with('userUpdateFailure', 'Cette adresse mail est déjà utilisée');
        }

        $user->update([
            'last_name' => $request->last_name,
            'first_name' => $request->first_name,
            'email' => $request->email,
            'password' => Hash::make($request->password),
            'avatar' => null,
            'title_id' => intval($request->title_id),
        ]);

        if ($request->group_id) $user->groups()->sync(array_map('intval', $request->group_id));
        else $user->groups()->sync([]);

        $user->roles()->sync(array_map('intval', $request->role_id));

        return back()->with('userUpdateSuccess', "L'utilisateur a été modifié avec succès");
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\User  $user
     * @return \Illuminate\Http\Response
     */
    public function destroy(User $user)
    {
        if (!$user) return redirect()->route('users.index')->with('userDeleteFailure', "Cet utilisateur n'existe pas");

        $this->authorize('delete', $user);

        $user->groups()->detach($user->groups()->pluck('id')->toArray());
        $user->roles()->detach($user->roles()->pluck('id')->toArray());
        $user->delete();

        return redirect()->route('users.index')->with('userDeleteSuccess', "L'utilisateur a été supprimé avec succès");
    }
}

app/View/Components/AppLayout.php
<?php

namespace App\View\Components;

use Illuminate\View\Component;

class AppLayout extends Component
{
    /**
     * Get the view / contents that represents the component.
     *
     * @return \Illuminate\View\View
     */
    public function render()
    {
        return view('layouts.app');
    }
}

resources/views/users/create.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="font-semibold text-xl text-gray-800 leading-tight">
            {{ __('Créer un utilisateur') }}
        </h2>
    </x-slot>
    <div class="py-12">
        <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
            <div class="bg-white overflow-hidden shadow-sm sm:rounded-lg">
                <div class="p-6 bg-white border-b border-gray-200">
                    @if (session('userCreateSuccess'))
                    <div class="bg-green-100 text-green-700 py-2 px-4 rounded mb-2" role="alert">
                        <span class="block sm:inline">{{ session('userCreateSuccess') }}</span>
                    </div>
                    @endif
                    @if (session('userCreateFailure'))
                    <div class="bg-red-100 text-red-700 py-2 px-4 rounded mb-2" role="alert">
                        <span class="block sm:inline">{{ session('userCreateFailure') }}</span>
                    </div>
                    @endif
                    <form action="{{ route('users.store') }}" method="POST" enctype="multipart/form-data">
                        @csrf
                        <div class="w-full flex flex-row justify-between">
                            <div class="flex flex-col w-1/2 -mx-3">
                                <div class="w-full px-3 mb-3">
                                    <label class="block uppercase tracking-wide text-xs font-bold mb-2">
                                        Civilité
                                    </label>
                                    <div class="flex flex-col md:flex-row">
                                    @foreach ($titles as $title)
                                    <div>
                                        <input id="titleInput-{{ $title->id }}" type="radio" name="title_id" value="{{ $title->id }}" @if ($title->id === App\Models\Title::MAN) checked @endif />
                                        <label for="titleInput-{{ $title->id }}" class="mr-5">{{ $title->long_name }}</label>
                                    </div>
                                    @endforeach
                                    </div>
                                </div>
                                <div class="w-full px-3 mb-3">
                                    <label class="block uppercase tracking-wide text-xs font-bold mb-2" for="lastNameInput">
                                        Nom
                                    </label>
                                    <input
                                        class="@error ('last_name') is-invalid @enderror appearance-none block w-full bg-gray-100 rounded py-3 px-4 md:mb-0"
                                        id="lastNameInput" type="text" name="last_name" value="{{ old('last_name') }}">
                                    @error ('last_name')
                                    <span class="text-red-600">{{ $message }}</span>
                                    @enderror
                                </div>
                                <div class="w-full px-3 mb-3">
                                    <label class="block uppercase tracking-wide text-xs font-bold mb-2" for="firstNameInput">
                                        Prénom
                                    </label>
                                    <input
                                        class="@error ('first_name') is-invalid @enderror appearance-none block w-full bg-gray-100 rounded py-3 px-4 md:mb-0"
                                        id="firstNameInput" type="text" name="first_name" value="{{ old('first_name') }}">
                                    @error ('first_name')
                                    <span class="text-red-600">{{ $message }}</span>
                                    @enderror
                                </div>
                                <div class="w-full px-3 mb-3">
                                    <label class="block uppercase tracking-wide text-xs font-bold mb-2" for="emailInput">
                                        Adresse mail
                                    </label>
                                    <input
                                        class="@error ('email') is-invalid @enderror appearance-none block w-full bg-gray-100 rounded py-3 px-4 md:mb-0"
                                        id="emailInput" type="email" name="email" value="{{ old('email') }}">
                                    @error ('email')
                                    <span class="text-red-600">{{ $message }}</span>
                                    @enderror
                                </div>
                                <div class="w-full px-3 mb-3"  x-data="{ show: true }">
                                    <label class="block uppercase tracking-wide text-xs font-bold mb-2" for="passwordInput">
                                        Mot de passe
                                    </label>
                                    <div class="relative">
                                        <input
                                            class="@error ('password') is-invalid @enderror appearance-none block w-full bg-gray-100 rounded py-3 px-4 md:mb-0"
                                            id="passwordInput" :type="show ? 'password' : 'text'" name="password">
                                        <div class="absolute inset-y-0 right-0 pr-3 flex items-center">
                                            <svg class="w-5 h-5" :class="{'hidden': !show, 'block': show }" @click="show = !show" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 576 512"><path d="M288 32c-80.8 0-145.5 36.8-192.6 80.6C48.6 156 17.3 208 2.5 243.7c-3.3 7.9-3.3 16.7 0 24.6C17.3 304 48.6 356 95.4 399.4C142.5 443.2 207.2 480 288 480s145.5-36.8 192.6-80.6c46.8-43.5 78.1-95.4 93-131.1c3.3-7.9 3.3-16.7 0-24.6c-14.9-35.7-46.2-87.7-93-131.1C433.5 68.8 368.8 32 288 32zM432 256c0 79.5-64.5 144-144 144s-144-64.5-144-144s64.5-144 144-144s144 64.5 144 144zM288 192c0 35.3-28.7 64-64 64c-11.5 0-22.3-3-31.6-8.4c-.2 2.8-.4 5.5-.4 8.4c0 53 43 96 96 96s96-43 96-96s-43-96-96-96c-2.8 0-5.6 .1-8.4 .4c5.3 9.3 8.4 20.1 8.4 31.6z"/></svg>
                                            <svg class="w-5 h-5" :class="{'hidden': show, 'block': !show }" @click="show = !show" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 640 512"><path d="M38.8 5.1C28.4-3.1 13.3-1.2 5.1 9.2S-1.2 34.7 9.2 42.9l592 464c10.4 8.2 25.5 6.3 33.7-4.1s6.3-25.5-4.1-33.7L525.6 386.7c39.6-40.6 66.4-86.1 79.9-118.4c3.3-7.9 3.3-16.7 0-24.6c-14.9-35.7-46.2-87.7-93-131.1C465.5 68.8 400.8 32 320 32c-68.2 0-125 26.3-169.3 60.8L38.8 5.1zM223.1 149.5C248.6 126.2 282.7 112 320 112c79.5 0 144 64.5 144 144c0 24.9-6.3 48.3-17.4 68.7L408 294.5c5.2-11.8 8-24.8 8-38.5c0-53-43-96-96-96c-2.8 0-5.6 .1-8.4 .4c5.3 9.3 8.4 20.1 8.4 31.6c0 10.2-2.4 19.8-6.6 28.3l-90.3-70.8zm223.1 298L373 389.9c-16.4 6.5-34.3 10.1-53 10.1c-79.5 0-144-64.5-144-144c0-6.9 .5-13.6 1.4-20.2L83.1 161.5C60.3 191.2 44 220.8 34.5 243.7c-3.3 7.9-3.3 16.7 0 24.6c14.9 35.7 46.2 87.7 93 131.1C174.5 443.2 239.2 480 320 480c47.8 0 89.9-12.9 126.2-32.5z"/></svg>
                                        </div>
                                    </div>
                                    @error ('password')
                                    <span class="text-red-600">{{ $message }}</span>
                                    @enderror
                                </div>
                                <div class="w-full px-3 mb-3">
                                    <label class="block uppercase tracking-wide text-xs font-bold mb-2" for="avatarInput">
                                        Avatar
                                    </label>
                                    <input
                                        class="@error ('avatar') is-invalid @enderror appearance-none block w-full"
                                        id="avatarInput" type="file" name="avatar">
                                    @error ('avatar')
                                    <span class="text-red-600">{{ $message }}</span>
                                    @enderror
                                </div>
                            </div>
                            <div class="flex flex-col w-1/2 h-full -mx-3">
                                <div class="w-full px-3 mb-10 md:mb-4">
                                    <label class="block uppercase tracking-wide text-xs font-bold mb-2">
                                        Rôles
                                    </label>
                                    <div class="h-48 px-1 overflow-y-auto">
                                        @foreach ($roles as $role)
                                        <div class="@error ('role_id') is-invalid @enderror form-check flex flex-row">
                                            <input class="form-check-input appearance-none h-4 w-4 border border-gray-300 rounded-sm bg-white checked:bg-blue-600 checked:border-blue-600 focus:outline-none transition duration-200 mt-1 align-top bg-no-repeat bg-center bg-contain float-left mr-2 cursor-pointer"
                                            id="roleInput-{{ $role->id }}" type="checkbox" name="role_id[]" value="{{ $role->id }}" @if ($role->id === \App\Models\Role::USER ) checked @endif>
                                            <label class="form-check-label inline-block text-gray-800" for="roleInput-{{ $role->id }}">
                                                {{ $role->name }}
                                            </label>
                                        </div>
                                        @endforeach
                                        @error ('role_id')
                                        <span class="text-red-600">{{ $message }}</span>
                                        @enderror
                                    </div>
                                </div>
                                <div class="w-full px-3 mb-3">
                                    <label class="block uppercase tracking-wide text-xs font-bold mb-2">
                                        Groupes
                                    </label>
                                    <div class="h-48 px-1 overflow-y-auto">
                                        @foreach ($groups as $group)
                                        <div class="form-check flex flex-row">
                                            <input class="form-check-input appearance-none h-4 w-4 border border-gray-300 rounded-sm bg-white checked:bg-blue-600 checked:border-blue-600 focus:outline-none transition duration-200 mt-1 align-top bg-no-repeat bg-center bg-contain float-left mr-2 cursor-pointer"
                                            id="groupInput-{{ $group->id }}" type="checkbox" name="group_id[]" value="{{ $group->id }}">
                                            <label class="form-check-label inline-block text-gray-800" for="groupInput-{{ $group->id }}">
                                                {{ $group->name }}
                                            </label>
                                        </div>
                                        @endforeach
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="mb-2 space-x-2">
                            <button type="submit" class="bg-indigo-500 hover:bg-indigo-600 text-white py-2 px-4 rounded">
                                Envoyer
                            </button>
                            <button type="button" class="bg-red-500 hover:bg-red-600 text-white py-2 px-4 rounded"
                                onclick="window.location='{{ route('users.index') }}'">
                                Annuler
                            </button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</x-app-layout>

resources/views/users/index.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="font-semibold text-xl text-gray-800 leading-tight">
            {{ __('Utilisateurs') }}
        </h2>
    </x-slot>
    <div class="py-12">
        <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
            <div class="bg-white overflow-hidden shadow-sm sm:rounded-lg">
                <div class="p-6 bg-white border-b border-gray-200">
                    @if (session('userViewFailure'))
                    <div class="bg-red-100 text-red-700 py-2 px-4 rounded mb-2" role="alert">
                        <span class="block sm:inline">{{ session('userViewFailure') }}</span>
                    </div>
                    @endif
                    @if (session('userDeleteSuccess'))
                    <div class="bg-green-100 text-green-700 py-2 px-4 rounded mb-2" role="alert">
                        <span class="block sm:inline">{{ session('userDeleteSuccess') }}</span>
                    </div>
                    @endif
                    @if (session('userDeleteFailure'))
                    <div class="bg-red-100 text-red-700 py-2 px-4 rounded mb-2" role="alert">
                        <span class="block sm:inline">{{ session('userDeleteFailure') }}</span>
                    </div>
                    @endif
                    @can ('create', \App\Models\User::class)
                    <a href="{{ route('users.create') }}" class="inline-flex justify-center items-center p-2 text-base font-medium text-gray-500 bg-gray-50 rounded-lg hover:text-gray-900 hover:bg-gray-100">
                        <svg class="w-5 h-5 mr-2" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><path d="M256 80c0-17.7-14.3-32-32-32s-32 14.3-32 32V224H48c-17.7 0-32 14.3-32 32s14.3 32 32 32H192V432c0 17.7 14.3 32 32 32s32-14.3 32-32V288H400c17.7 0 32-14.3 32-32s-14.3-32-32-32H256V80z"/></svg>
                        <span>Créer un utilisateur</span>
                    </a>
                    @endcan
                    <div class="flex flex-col">
                        @foreach ($users as $user)
                        @if (auth()->user()->can('view', $user))
                        <li><a href={{ route('users.show', $user) }}>{{ $user->first_name }}</a></li>
                        @else
                        <li>{{ $user->first_name }}</li>
                        @endif
                        @endforeach
                    </div>
                </div>
            </div>
        </div>
    </div>
</x-app-layout>

resources/views/users/show.blade.php
<x-app-layout>
    <x-slot name="header">
        <h2 class="font-semibold text-xl text-gray-800 leading-tight">
            {{ __($user->first_name . ' ' . $user->last_name) }}
        </h2>
    </x-slot>
    <div class="py-12">
        <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
            <div class="bg-white overflow-hidden shadow-sm sm:rounded-lg">
                <div class="relative p-6 bg-white border-b border-gray-200">
                    <div class="absolute top-4 right-4">
                        @can ('update', $user)
                        <a href="{{ route('users.edit', $user) }}" class="inline-flex justify-center items-center p-2 text-base font-medium text-gray-500 bg-gray-50 rounded-lg hover:text-gray-900 hover:bg-gray-100">
                            <svg class="w-5 h-5" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 512 512"><path d="M471.6 21.7c-21.9-21.9-57.3-21.9-79.2 0L362.3 51.7l97.9 97.9 30.1-30.1c21.9-21.9 21.9-57.3 0-79.2L471.6 21.7zm-299.2 220c-6.1 6.1-10.8 13.6-13.5 21.9l-29.6 88.8c-2.9 8.6-.6 18.1 5.8 24.6s15.9 8.7 24.6 5.8l88.8-29.6c8.2-2.8 15.7-7.4 21.9-13.5L437.7 172.3 339.7 74.3 172.4 241.7zM96 64C43 64 0 107 0 160V416c0 53 43 96 96 96H352c53 0 96-43 96-96V320c0-17.7-14.3-32-32-32s-32 14.3-32 32v96c0 17.7-14.3 32-32 32H96c-17.7 0-32-14.3-32-32V160c0-17.7 14.3-32 32-32h96c17.7 0 32-14.3 32-32s-14.3-32-32-32H96z"/></svg>
                        </a>
                        @endcan
                        @can ('delete', $user)
                            <form class="inline-flex justify-center items-center p-2 text-base font-medium text-gray-500 bg-gray-50 rounded-lg hover:text-gray-900 hover:bg-gray-100" id="form-{{ $user->id }}" action="{{ route('users.destroy', $user) }}" method="POST" enctype="multipart/form-data">
                                @csrf
                                @method('DELETE')
                                <input type="hidden" name="_method" value="DELETE">
                                <button type="submit">
                                    <svg class="w-5 h-5" xmlns="http://www.w3.org/2000/svg" viewBox="0 0 448 512"><path d="M135.2 17.7L128 32H32C14.3 32 0 46.3 0 64S14.3 96 32 96H416c17.7 0 32-14.3 32-32s-14.3-32-32-32H320l-7.2-14.3C307.4 6.8 296.3 0 284.2 0H163.8c-12.1 0-23.2 6.8-28.6 17.7zM416 128H32L53.2 467c1.6 25.3 22.6 45 47.9 45H346.9c25.3 0 46.3-19.7 47.9-45L416 128z"/></svg>
                                </button>
                            </form>
                        @endcan
                    </div>
                    <div>
                        <div class="flex flex-col">
                            <span class="mb-4">{{ $user->title->short_name }} {{ $user->first_name }} {{ $user->last_name }}</span>
                            <span>Adresse mail : {{ $user->email }}</span>
                            @if ($user->groups->first())
                            <span>Groupes :</span>
                            @foreach ($user->groups->sortBy('name') as $group)
                            @if (auth()->user()->can('view', $group))
                            <li><a href={{ route('groups.show', $group) }}>{{ $group->name }}</a></li>
                            @else
                            <li>{{ $group->name }}</li>
                            @endif
                            @endforeach
                            @endif
                        </div>
                        <div>
                            <span>Rôles :</span>
                            @foreach ($user->roles->sortBy('name') as $role)
                            @if (auth()->user()->can('view', $role))
                            <li><a href={{ route('roles.show', $role) }}>{{ $role->name }}</a></li>
                            @else
                            <li>{{ $role->name }}</li>
                            @endif
                            @endforeach
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</x-app-layout>